Index: issm/trunk/src/m/classes/geometry.m
===================================================================
--- issm/trunk/src/m/classes/geometry.m	(revision 25994)
+++ issm/trunk/src/m/classes/geometry.m	(revision 26744)
@@ -33,11 +33,4 @@
 	end
 	methods
-		function self = extrude(self,md) % {{{
-			self.surface=project3d(md,'vector',self.surface,'type','node');
-			self.thickness=project3d(md,'vector',self.thickness,'type','node');
-			self.hydrostatic_ratio=project3d(md,'vector',self.hydrostatic_ratio,'type','node');
-			self.base=project3d(md,'vector',self.base,'type','node');
-			self.bed=project3d(md,'vector',self.bed,'type','node');
-		end % }}}
 		function self = geometry(varargin) % {{{
 			switch nargin
@@ -53,10 +46,5 @@
 		function md = checkconsistency(self,md,solution,analyses) % {{{
 
-			if (strcmp(solution,'TransientSolution') & md.transient.isgia) | strcmp(solution,'GiaSolution'),
-				md = checkfield(md,'fieldname','geometry.thickness','timeseries',1,'NaN',1,'Inf',1);
-			elseif strcmpi(solution,'SealevelriseSolution'),
-				md = checkfield(md,'fieldname','geometry.bed','NaN',1,'Inf',1,'size',[md.mesh.numberofvertices 1]);
-				return;
-			elseif strcmpi(solution,'LoveSolution'),
+			if strcmpi(solution,'LoveSolution'),
 				return; 
 			else
@@ -90,9 +78,24 @@
 		end % }}}
 		function marshall(self,prefix,md,fid) % {{{
+			length_thickness=size(self.thickness,1);
+			if length_thickness==md.mesh.numberofvertices | length_thickness==md.mesh.numberofvertices+1,
+				WriteData(fid,prefix,'object',self,'fieldname','thickness','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
+			elseif length_thickness==md.mesh.numberofelements | length_thickness==md.mesh.numberofelements+1,
+				WriteData(fid,prefix,'object',self,'fieldname','thickness','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofelements+1,'yts',md.constants.yts);
+			else
+				error('geometry thickness time series should be a vertex or element time series');
+			end
+
 			WriteData(fid,prefix,'object',self,'fieldname','surface','format','DoubleMat','mattype',1);
-			WriteData(fid,prefix,'object',self,'fieldname','thickness','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
 			WriteData(fid,prefix,'object',self,'fieldname','base','format','DoubleMat','mattype',1);
 			WriteData(fid,prefix,'object',self,'fieldname','bed','format','DoubleMat','mattype',1);
 			WriteData(fid,prefix,'object',self,'fieldname','hydrostatic_ratio','format','DoubleMat','mattype',1);
+		end % }}}
+		function self = extrude(self,md) % {{{
+			self.surface=project3d(md,'vector',self.surface,'type','node');
+			self.thickness=project3d(md,'vector',self.thickness,'type','node');
+			self.hydrostatic_ratio=project3d(md,'vector',self.hydrostatic_ratio,'type','node');
+			self.base=project3d(md,'vector',self.base,'type','node');
+			self.bed=project3d(md,'vector',self.bed,'type','node');
 		end % }}}
 		function savemodeljs(self,fid,modelname) % {{{
Index: issm/trunk/src/m/classes/geometry.py
===================================================================
--- issm/trunk/src/m/classes/geometry.py	(revision 25994)
+++ issm/trunk/src/m/classes/geometry.py	(revision 26744)
@@ -14,5 +14,5 @@
     """
 
-    def __init__(self, *args): #{{{
+    def __init__(self, *args):  # {{{
         self.surface = np.nan
         self.thickness = np.nan
@@ -21,12 +21,11 @@
         self.hydrostatic_ratio = np.nan
 
-        nargs = len(args)
-        if nargs == 0:
+        if len(args) == 0:
             self.setdefaultparameters()
         else:
             raise Exception('constructor not supported')
-    #}}}
+    # }}}
 
-    def __repr__(self): #{{{
+    def __repr__(self):  # {{{
         s = '   geometry parameters:\n'
         s += '{}\n'.format(fielddisplay(self, 'surface', 'ice upper surface elevation [m]'))
@@ -35,7 +34,46 @@
         s += '{}\n'.format(fielddisplay(self, 'bed', 'bed elevation [m]'))
         return s
-    #}}}
+    # }}}
 
-    def extrude(self, md): #{{{
+    def setdefaultparameters(self):  # {{{
+        return
+    # }}}
+
+    def checkconsistency(self, md, solution, analyses):  # {{{
+        if solution == 'LoveSolution':
+            return md
+        else:
+            md = checkfield(md, 'fieldname', 'geometry.surface', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
+            md = checkfield(md, 'fieldname', 'geometry.base', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
+            md = checkfield(md, 'fieldname', 'geometry.thickness', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices], '>=', 0)
+            if any(abs(self.thickness - self.surface + self.base) > 1e-9):
+                md.checkmessage('equality thickness = surface-base violated')
+            if solution == 'TransientSolution' and md.transient.isgroundingline:
+                md = checkfield(md, 'fieldname', 'geometry.bed', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
+                if np.any(self.bed - self.base > 1e-12):
+                    md.checkmessage('base < bed on one or more vertex')
+                pos = np.where(md.mask.ocean_levelset > 0)
+                if np.any(np.abs(self.bed[pos] - self.base[pos]) > 1e-9):
+                    md.checkmessage('equality base = bed on grounded ice violated')
+                md = checkfield(md, 'fieldname', 'geometry.bed', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
+        return md
+    # }}}
+
+    def marshall(self, prefix, md, fid):  # {{{
+        length_thickness = len(self.thickness)
+        if (length_thickness == md.mesh.numberofvertices) or (length_thickness == md.mesh.numberofvertices + 1):
+            WriteData(fid, prefix, 'object', self, 'fieldname', 'thickness', 'format', 'DoubleMat', 'mattype', 1, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', md.constants.yts)
+        elif (length_thickness == md.mesh.numberofelements) or (length_thickness == md.mesh.numberofelements + 1):
+            WriteData(fid, prefix, 'object', self, 'fieldname', 'thickness', 'format', 'DoubleMat', 'mattype', 1, 'timeserieslength', md.mesh.numberofelements + 1, 'yts', md.constants.yts)
+        else:
+            raise RuntimeError('geometry thickness time series should be a vertex or element time series')
+
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'surface', 'format', 'DoubleMat', 'mattype', 1)
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'base', 'format', 'DoubleMat', 'mattype', 1)
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'bed', 'format', 'DoubleMat', 'mattype', 1)
+        WriteData(fid, prefix, 'object', self, 'fieldname', 'hydrostatic_ratio', 'format', 'DoubleMat', 'mattype', 1)
+    # }}}
+
+    def extrude(self, md):  # {{{
         self.surface = project3d(md, 'vector', self.surface, 'type', 'node')
         self.thickness = project3d(md, 'vector', self.thickness, 'type', 'node')
@@ -44,40 +82,3 @@
         self.bed = project3d(md, 'vector', self.bed, 'type', 'node')
         return self
-    #}}}
-
-    def setdefaultparameters(self): #{{{
-        return self
-    #}}}
-
-    def checkconsistency(self, md, solution, analyses): #{{{
-        if (solution == 'TransientSolution' and md.transient.isgia) or (solution == 'GiaSolution'):
-            md = checkfield(md, 'fieldname', 'geometry.thickness', 'timeseries', 1, 'NaN', 1, 'Inf', 1)
-        elif solution == 'SealevelriseSolution':
-            md = checkfield(md, 'fieldname', 'geometry.bed', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
-        elif solution == 'LoveSolution':
-            return
-        else:
-            md = checkfield(md, 'fieldname', 'geometry.surface', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
-            md = checkfield(md, 'fieldname', 'geometry.base', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
-            md = checkfield(md, 'fieldname', 'geometry.thickness', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices], '>', 0, 'timeseries', 1)
-            if any(abs(self.thickness - self.surface + self.base) > 10**-9):
-                md.checkmessage("equality thickness = surface-base violated")
-            if solution == 'TransientSolution' and md.transient.isgroundingline:
-                md = checkfield(md, 'fieldname', 'geometry.bed', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
-                if np.any(self.bed - self.base > 10**-12):
-                    md.checkmessage('base < bed on one or more vertex')
-                pos = np.where(md.mask.ocean_levelset > 0)
-                if np.any(np.abs(self.bed[pos] - self.base[pos]) > 10**-9):
-                    md.checkmessage('equality base = bed on grounded ice violated')
-                md = checkfield(md, 'fieldname', 'geometry.bed', 'NaN', 1, 'Inf', 1, 'size', [md.mesh.numberofvertices])
-
-        return md
     # }}}
-
-    def marshall(self, prefix, md, fid): #{{{
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'surface', 'format', 'DoubleMat', 'mattype', 1)
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'thickness', 'format', 'DoubleMat', 'mattype', 1, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', md.constants.yts)
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'base', 'format', 'DoubleMat', 'mattype', 1)
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'bed', 'format', 'DoubleMat', 'mattype', 1)
-        WriteData(fid, prefix, 'object', self, 'fieldname', 'hydrostatic_ratio', 'format', 'DoubleMat', 'mattype', 1)
-    # }}}
Index: issm/trunk/src/m/classes/groundingline.js
===================================================================
--- issm/trunk/src/m/classes/groundingline.js	(revision 25994)
+++ issm/trunk/src/m/classes/groundingline.js	(revision 26744)
@@ -8,7 +8,7 @@
 	this.setdefaultparameters = function(){// {{{
 		//Type of migration
-		this.migration='AggressiveMigration';
-		this.friction_interpolation='SubelementFriction1';
-		this.melt_interpolation='NoMeltOnPartiallyFloating';
+		this.migration				= 'SubelementMigration';
+		this.friction_interpolation	= 'SubelementFriction1';
+		this.melt_interpolation		= 'NoMeltOnPartiallyFloating';
 
 	}// }}}
@@ -29,15 +29,15 @@
 			checkfield(md,'fieldname','groundingline.melt_interpolation','values',['NoMeltOnPartiallyFloating', 'SubelementMelt1', 'SubelementMelt2', 'FullMeltOnPartiallyFloating']);
 
-			if(this.migration !='None' & md.trans.isgroundingline==1 & solution == 'TransientSolution'){
+			if (this.migration !='None'){
 				if (isNaN(md.geometry.bed)){
 					md.checkmessage('requesting grounding line migration, but bathymetry is absent!');
 				}
 				for (var i=0;i<md.mesh.numberofvertices;i++){
-					if(md.mask.ocean_levelset[i]>0){
+					if(md.mask.groundedice_levelset[i]>0){
 						md.checkmessage('base not equal to bed on grounded ice!');
 						break;
 					}
 					if(md.geometry.bed[i] - md.geometry.base[i] > Math.pow(10,-9)){
-						md = checkmessage(md,'bed superior to base on floating ice!');
+						checkmessage(md,'bed superior to base on floating ice!');
 						break;
 					}
@@ -47,6 +47,6 @@
 		this.marshall=function(md,prefix,fid) { //{{{
 			WriteData(fid,prefix,'data',this.migration,'name','md.groundingline.migration','format','String');
-			WriteData(fid,prefix,'data',this.migration,'name','md.groundingline.friction_interpolation','format','String');
-			WriteData(fid,prefix,'data',this.migration,'name','md.groundingline.melt_interpolation','format','String');
+			WriteData(fid,prefix,'data',this.friction_interpolation,'name','md.groundingline.friction_interpolation','format','String');
+			WriteData(fid,prefix,'data',this.melt_interpolation,'name','md.groundingline.melt_interpolation','format','String');
 		}//}}}
 		this.fix=function() { //{{{
Index: issm/trunk/src/m/classes/groundingline.py
===================================================================
--- issm/trunk/src/m/classes/groundingline.py	(revision 25994)
+++ issm/trunk/src/m/classes/groundingline.py	(revision 26744)
@@ -1,7 +1,7 @@
 import numpy as np
+from checkfield import checkfield
 from fielddisplay import fielddisplay
-from checkfield import checkfield
+import MatlabFuncs as m
 from WriteData import WriteData
-import MatlabFuncs as m
 
 
@@ -19,21 +19,19 @@
         self.melt_interpolation = ''
 
-    #set defaults
+        # Set defaults
         self.setdefaultparameters()
 
-    #}}}
+    # }}}
 
     def __repr__(self):  # {{{
-        string = '   grounding line migration parameters:'
-
-        string = "%s\n%s" % (string, fielddisplay(self, 'migration', 'type of grounding line migration: ''SoftMigration'', ''SubelementMigration'', ''AggressiveMigration'', ''Contact'', ''None'''))
-        string = "%s\n%s" % (string, fielddisplay(self, 'migration', 'type of friction interpolation on partially floating elements: ''SubelementFriction1'', ''SubelementFriction2'', ''NoFrictionOnPartiallyFloating'''))
-        string = "%s\n%s" % (string, fielddisplay(self, 'migration', 'type of melt interpolation on partially floating elements: ''SubelementMelt1'', ''SubelementMelt2'', ''NoMeltOnPartiallyFloating'', ''FullMeltOnPartiallyFloating'''))
-        return string
-    #}}}
+        s = '   grounding line migration parameters:\n'
+        s += '{}\n'.format(fielddisplay(self, 'migration', 'type of grounding line migration: \'SoftMigration\', \'SubelementMigration\', \'AggressiveMigration\', \'Contact\', \'None\''))
+        s += '{}\n'.format(fielddisplay(self, 'migration', 'type of friction interpolation on partially floating elements: ''SubelementFriction1'', ''SubelementFriction2'', ''NoFrictionOnPartiallyFloating'''))
+        s += '{}\n'.format(fielddisplay(self, 'migration', 'type of melt interpolation on partially floating elements: \'SubelementMelt1\', \'SubelementMelt2\', \'NoMeltOnPartiallyFloating\', \'FullMeltOnPartiallyFloating\''))
+        return s
+    # }}}
 
     def setdefaultparameters(self):  # {{{
-
-        #Type of migration
+        # Type of migration
         self.migration = 'SubelementMigration'
         self.friction_interpolation = 'SubelementFriction1'
@@ -41,8 +39,7 @@
 
         return self
-    #}}}
+    # }}}
 
     def checkconsistency(self, md, solution, analyses):  # {{{
-
         md = checkfield(md, 'fieldname', 'groundingline.migration', 'values', ['None', 'SubelementMigration', 'AggressiveMigration', 'SoftMigration', 'Contact', 'GroundingOnly'])
         md = checkfield(md, 'fieldname', 'groundingline.friction_interpolation', 'values', ['SubelementFriction1', 'SubelementFriction2', 'NoFrictionOnPartiallyFloating'])
@@ -53,7 +50,7 @@
                 md.checkmessage("requesting grounding line migration, but bathymetry is absent!")
             pos = np.nonzero(md.mask.ocean_levelset > 0.)[0]
-            if any(np.abs(md.geometry.base[pos] - md.geometry.bed[pos]) > 10**-10):
+            if any(np.abs(md.geometry.base[pos] - md.geometry.bed[pos]) > pow(10, -10)):
                 md.checkmessage("base not equal to bed on grounded ice!")
-            if any(md.geometry.bed - md.geometry.base > 10**-9):
+            if any(md.geometry.bed - md.geometry.base > pow(10, -9)):
                 md.checkmessage("bed superior to base on floating ice!")
 
Index: issm/trunk/src/m/classes/hydrologydc.py
===================================================================
--- issm/trunk/src/m/classes/hydrologydc.py	(revision 25994)
+++ issm/trunk/src/m/classes/hydrologydc.py	(revision 26744)
@@ -7,9 +7,8 @@
 
 class hydrologydc(object):
-    """
-    Hydrologydc class definition
+    """HYDROLOGYDC class definition
 
     Usage:
-            hydrologydc = hydrologydc()
+        hydrologydc = hydrologydc()
     """
 
@@ -49,9 +48,12 @@
         self.eplflip_lock = 0
 
-    #set defaults
         self.setdefaultparameters()
     # }}}
 
     def __repr__(self):  # {{{
+        # TODO:
+        # - Convert all formatting to calls to <string>.format (see any 
+        #   already converted <class>.__repr__ method for examples)
+        #
         string = '   hydrology Dual Porous Continuum Equivalent parameters:'
         string = ' - general parameters'
Index: issm/trunk/src/m/classes/hydrologyshreve.js
===================================================================
--- issm/trunk/src/m/classes/hydrologyshreve.js	(revision 25994)
+++ issm/trunk/src/m/classes/hydrologyshreve.js	(revision 26744)
@@ -1,73 +1,74 @@
-//HYDROLOGYSHREVE class definition
-//
-//   Usage:
-//      hydrologyshreve=new hydrologyshreve();
+class hydrologyshreve {//{{{
+	/**
+	 * HYDROLOGYSHREVE class definition
+	 *
+	 * Usage:
+	 *     hydrologyshreve = hydrologyshreve();
+	 */
+	constructor() {//{{{
+		this.spcwatercolumn = NaN;
+		this.stabilization = 0;
+		this.requested_outputs = [];
 
-function hydrologyshreve (){
-	//methods
-	this.setdefaultparameters = function(){// {{{
+		if (arguments.length == 0) {
+			this.setdefaultparameters();
+		} else {
+			error('constructor not supported');
+		}
+	} //}}}
 
-		//Type of stabilization to use 0:nothing 1:artificial_diffusivity
-		this.stabilization=1;
+	disp() {//{{{
+		console.log(sprintf('   hydrologyshreve solution parameters:'));
+		fielddisplay(this, 'spcwatercolumn', 'water thickness constraints (NaN means no constraint) [m]');
+		fielddisplay(this, 'stabilization', 'artificial diffusivity (default: 1). can be more than 1 to increase diffusivity.');
+		fielddisplay(this, 'requested_outputs', 'additional outputs requested');
+	} //}}}
 
-		//default output
-		this.requested_outputs=['default'];
+	setdefaultparameters() {//{{{
+		// Type of stabilization to use 0:nothing 1:artificial_diffusivity
+		this.stabilization = 1;
+		this.requested_outputs = ['default'];
+	} //}}}
 
-	}// }}}
-		this.disp= function(){// {{{
+	checkconsistency(md, solution, analyses) {//{{{
+		// Early return
+		if (!analyses.contains('HydrologyShreveAnalysis') || (solution == 'TransientSolution' && !md.transient.ishydrology)) {
+			return md;
+		}
+		md = checkfield(md, 'fieldname', 'hydrology.spcwatercolumn', 'Inf', 1, 'timeseries', 1);
+		md = checkfield(md, 'fieldname', 'hydrology.stabilization', '>=', 0);
+		return md;
+	} //}}}
 
-		console.log(sprintf('   hydrologyshreve solution parameters:'));
-		fielddisplay(this,'spcwatercolumn','water thickness constraints (NaN means no constraint) [m]');
-		fielddisplay(this,'stabilization','artificial diffusivity (default is 1). can be more than 1 to increase diffusivity.');
-		fielddisplay(this,'requested_outputs','additional outputs requested');
+	defaultoutputs(md) {//{{{
+		return ['Watercolumn', 'HydrologyWaterVx', 'HydrologyWaterVy'];
+	} //}}}
 
-	}// }}}
-    this.extrude = function(md) {//{{{
-        return this;
-    };//}}}
-		this.classname= function(){// {{{
-			return "hydrologyshreve";
+	marshall(md, prefix, fid) {//{{{
+		WriteData(fid, prefix, 'name', 'md.hydrology.model', 'data', 2, 'format', 'Integer');
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'spcwatercolumn', 'format', 'DoubleMat', 'mattype', 1, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', md.constants.yts);
+		WriteData(fid, prefix, 'object', this, 'fieldname', 'stabilization', 'format', 'Double');
 
-		}// }}}
-	this.type= function(){// {{{
+		// Process requested outputs
+		let outputs = this.requested_outputs;
+		let pos = find(ismember(outputs, 'default'));
+		if (pos.length) {
+			/*
+			NOTE: In order to handle case where user has added 'default' more 
+			than once to this.requested_outputs, need to remove elements by 
+			index in reverse order.
+			*/
+			for (let i = (pos.length - 1); i >= 0; --i) {
+				outputs.splice(pos[i], 1);
+			}
+			let default_outputs = this.defaultoutputs(md);
+			for (let i = 0; i < default_outputs.length; ++i) {
+				outputs.push(default_outputs[i]);
+			}
+		}
+		WriteData(fid, prefix, 'data', outputs, 'name', 'md.hydrology.requested_outputs', 'format', 'StringArray');
+	} //}}}
 
-		return "hydrologyshreve";
-	}// }}}
-		this.checkconsistency = function(md,solution,analyses) { //{{{
-
-			//Early return
-			if(!ArrayAnyEqual(ArrayIsMember('HydrologyShreveAnalysis',analyses),1)) return;
-
-			checkfield(md,'fieldname','hydrology.spcwatercolumn','Inf',1,'timeseries',1);
-			checkfield(md,'fieldname','hydrology.stabilization','>=',0);
-			checkfield(md,'fieldname','hydrology.requested_outputs','stringrow',1);
-
-		} // }}}
-		this.marshall=function(md,prefix,fid) { //{{{
-			WriteData(fid,prefix,'name','md.hydrology.model','data',2,'format','Integer');
-			WriteData(fid,prefix,'object',this,'fieldname','spcwatercolumn','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
-			WriteData(fid,prefix,'object',this,'fieldname','stabilization','format','Double');
-			var outputs = this.requested_outputs;
-			for (var i=0;i<outputs.length;i++){
-				if (outputs[i] == 'default') {
-					outputs.splice(i,1);
-					var newoutputs=this.defaultoutputs(md);
-					for (var j=0;j<newoutputs.length;j++) outputs.push(newoutputs[j]);
-				}
-			}
-			WriteData(fid,prefix,'data',outputs,'name','md.hydrology.requested_outputs','format','StringArray');
-		}//}}}
-		this.defaultoutputs = function(md) { //{{{
-				return ['Watercolumn','HydrologyWaterVx','HydrologyWaterVy'];
-		}//}}}
-		this.fix=function() { //{{{
-			this.spcwatercolumn=NullFix(this.spcwatercolumn,NaN);
-		}//}}}
-	//properties 
-	// {{{
-	this.spcwatercolumn = NaN;
-	this.stabilization  = 0;
-	this.requested_outputs = [];
-	this.setdefaultparameters();
-	//}}}
-}
+	extrude(md) {//{{{
+	} //}}}
+} //}}}
Index: issm/trunk/src/m/classes/hydrologyshreve.m
===================================================================
--- issm/trunk/src/m/classes/hydrologyshreve.m	(revision 25994)
+++ issm/trunk/src/m/classes/hydrologyshreve.m	(revision 26744)
@@ -11,6 +11,4 @@
 	end
 	methods
-		function self = extrude(self,md) % {{{
-		end % }}}
 		function self = hydrologyshreve(varargin) % {{{
 			switch nargin
@@ -23,30 +21,27 @@
 			end
 		end % }}}
-		function list = defaultoutputs(self,md) % {{{
-			list = {'Watercolumn','HydrologyWaterVx','HydrologyWaterVy'};
-		end % }}}    
+		function disp(self) % {{{
+			disp(sprintf('   hydrologyshreve solution parameters:'));
+			fielddisplay(self,'spcwatercolumn','water thickness constraints (NaN means no constraint) [m]');
+			fielddisplay(self,'stabilization','artificial diffusivity (default: 1). can be more than 1 to increase diffusivity.');
+			fielddisplay(self,'requested_outputs','additional outputs requested');
 
+		end % }}}
 		function self = setdefaultparameters(self) % {{{
 
 			%Type of stabilization to use 0:nothing 1:artificial_diffusivity
 			self.stabilization     = 1;
-      self.requested_outputs = {'default'};
+			self.requested_outputs = {'default'};
 		end % }}}
 		function md = checkconsistency(self,md,solution,analyses) % {{{
 
 			%Early return
-			if ~ismember('HydrologyShreveAnalysis',analyses)
-				return;
-			end
+			if ~ismember('HydrologyShreveAnalysis',analyses) | (strcmp(solution,'TransientSolution') & md.transient.ishydrology==0), return; end
 
 			md = checkfield(md,'fieldname','hydrology.spcwatercolumn','Inf',1,'timeseries',1);
 			md = checkfield(md,'fieldname','hydrology.stabilization','>=',0);
 		end % }}}
-		function disp(self) % {{{
-			disp(sprintf('   hydrologyshreve solution parameters:'));
-			fielddisplay(self,'spcwatercolumn','water thickness constraints (NaN means no constraint) [m]');
-			fielddisplay(self,'stabilization','artificial diffusivity (default is 1). can be more than 1 to increase diffusivity.');
-      fielddisplay(self,'requested_outputs','additional outputs requested');
-
+		function list = defaultoutputs(self,md) % {{{
+			list = {'Watercolumn','HydrologyWaterVx','HydrologyWaterVy'};
 		end % }}}
 		function marshall(self,prefix,md,fid) % {{{
@@ -54,11 +49,13 @@
 			WriteData(fid,prefix,'object',self,'fieldname','spcwatercolumn','format','DoubleMat','mattype',1,'timeserieslength',md.mesh.numberofvertices+1,'yts',md.constants.yts);
 			WriteData(fid,prefix,'object',self,'fieldname','stabilization','format','Double');
-      outputs = self.requested_outputs;
-      pos  = find(ismember(outputs,'default'));
-      if ~isempty(pos),
-        outputs(pos) = [];  %remove 'default' from outputs
-        outputs      = [outputs defaultoutputs(self,md)]; %add defaults
-      end
-      WriteData(fid,prefix,'data',outputs,'name','md.hydrology.requested_outputs','format','StringArray');
+			outputs = self.requested_outputs;
+			pos = find(ismember(outputs,'default'));
+			if ~isempty(pos),
+				outputs(pos) = []; %remove 'default' from outputs
+				outputs      = [outputs defaultoutputs(self,md)]; %add defaults
+			end
+			WriteData(fid,prefix,'data',outputs,'name','md.hydrology.requested_outputs','format','StringArray');
+		end % }}}
+		function self = extrude(self,md) % {{{
 		end % }}}
 		function savemodeljs(self,fid,modelname) % {{{
Index: issm/trunk/src/m/classes/hydrologyshreve.py
===================================================================
--- issm/trunk/src/m/classes/hydrologyshreve.py	(revision 25994)
+++ issm/trunk/src/m/classes/hydrologyshreve.py	(revision 26744)
@@ -1,2 +1,4 @@
+import numpy as np
+
 from fielddisplay import fielddisplay
 from checkfield import checkfield
@@ -5,67 +7,65 @@
 
 class hydrologyshreve(object):
-    """
-    HYDROLOGYSHREVE class definition
+    """HYDROLOGYSHREVE class definition
 
-       Usage:
-          hydrologyshreve = hydrologyshreve()
+    Usage:
+        hydrologyshreve = hydrologyshreve()
     """
 
-    def __init__(self):  # {{{
-        self.spcwatercolumn = float('NaN')
+    def __init__(self, *args): #{{{
+        self.spcwatercolumn = np.nan
         self.stabilization = 0
         self.requested_outputs = []
-    #set defaults
-        self.setdefaultparameters()
 
+        nargs = len(args)
+        if nargs == 0:
+            self.setdefaultparameters()
+        elif nargs == 1:
+            self.setdefaultparameters(args)
+        else:
+            raise RuntimeError('constructor not supported')
     #}}}
 
-    def __repr__(self):  # {{{
-
-        string = '   hydrologyshreve solution parameters:'
-        string = "%s\n%s" % (string, fielddisplay(self, 'spcwatercolumn', 'water thickness constraints (NaN means no constraint) [m]'))
-        string = "%s\n%s" % (string, fielddisplay(self, 'stabilization', 'artificial diffusivity (default is 1). can be more than 1 to increase diffusivity.'))
-        string = "%s\n%s" % (string, fielddisplay(self, 'requested_outputs', 'additional outputs requested'))
-        return string
+    def __repr__(self): #{{{
+        s = '   hydrologyshreve solution parameters:\n'
+        s += '{}\n'.format(fielddisplay(self, 'spcwatercolumn', 'water thickness constraints (NaN means no constraint) [m]'))
+        s += '{}\n'.format(fielddisplay(self, 'stabilization', 'artificial diffusivity (default: 1). can be more than 1 to increase diffusivity.'))
+        s += '{}\n'.format(fielddisplay(self, 'requested_outputs', 'additional outputs requested'))
+        return s
     #}}}
 
-    def extrude(self, md):  # {{{
-        return self
+    def setdefaultparameters(self): #{{{
+        # Type of stabilization to use 0:nothing 1:artificial_diffusivity
+        self.stabilization = 1
+        self.requested_outputs = ['default']
     #}}}
 
-    def setdefaultparameters(self):  # {{{
-        #Type of stabilization to use 0:nothing 1:artificial_diffusivity
-        self.stabilization = 1
-        self.requested_outputs = ['default']
-        return self
-    #}}}
-
-    def defaultoutputs(self, md):  # {{{
-        list = ['Watercolumn', 'HydrologyWaterVx', 'HydrologyWaterVy']
-        return list
-    #}}}
-
-    def checkconsistency(self, md, solution, analyses):  # {{{
+    def checkconsistency(self, md, solution, analyses): #{{{
         #Early return
-        if 'HydrologyShreveAnalysis' not in analyses:
+        if 'HydrologyShreveAnalysis' not in analyses or (solution == 'TransientSolution' and not md.transient.ishydrology):
             return md
 
         md = checkfield(md, 'fieldname', 'hydrology.spcwatercolumn', 'Inf', 1, 'timeseries', 1)
         md = checkfield(md, 'fieldname', 'hydrology.stabilization', '>=', 0)
-        md = checkfield(md, 'fieldname', 'hydrology.requested_outputs', 'stringrow', 1)
         return md
     # }}}
 
-    def marshall(self, prefix, md, fid):  # {{{
+    def defaultoutputs(self, md): #{{{
+        return ['Watercolumn', 'HydrologyWaterVx', 'HydrologyWaterVy']
+    #}}}
+
+    def marshall(self, prefix, md, fid): #{{{
         WriteData(fid, prefix, 'name', 'md.hydrology.model', 'data', 2, 'format', 'Integer')
         WriteData(fid, prefix, 'object', self, 'fieldname', 'spcwatercolumn', 'format', 'DoubleMat', 'mattype', 1, 'timeserieslength', md.mesh.numberofvertices + 1, 'yts', md.constants.yts)
         WriteData(fid, prefix, 'object', self, 'fieldname', 'stabilization', 'format', 'Double')
-    #process requested outputs
         outputs = self.requested_outputs
         indices = [i for i, x in enumerate(outputs) if x == 'default']
-        if len(indices) > 0:
+        if len(indices):
             outputscopy = outputs[0:max(0, indices[0] - 1)] + self.defaultoutputs(md) + outputs[indices[0] + 1:]
             outputs = outputscopy
         WriteData(fid, prefix, 'data', outputs, 'name', 'md.hydrology.requested_outputs', 'format', 'StringArray')
+    # }}}
 
-    # }}}
+    def extrude(self, md): #{{{
+        return self
+    #}}}
